<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Under Water Drone: scene.cpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Under Water Drone
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',false,false,'search.php','Search');
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('scene_8cpp_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">scene.cpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="scene_8cpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="scene_8hh.html">scene.hh</a>&quot;</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160; </div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &lt;chrono&gt;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#include &lt;thread&gt;</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="keyword">using namespace </span>std::this_thread;</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="keyword">using namespace </span>std::chrono;</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div>
<div class="line"><a name="l00010"></a><span class="lineno"><a class="line" href="class_scene.html#ad10176d75a9cc0da56626f682d083507">   10</a></span>&#160;<a class="code" href="class_scene.html#ad10176d75a9cc0da56626f682d083507">Scene::Scene</a>() {</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;    link_.Init();</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;    link_.SetDrawingMode(<a class="code" href="namespace_pz_g.html#a4360c76a1dbf714a19a0d97fe56e0660aa7ef207217913b87d83fdf559d8368c7">PzG::DM_3D</a>);</div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    bottom_surface_.draw(bottom_surface_.kBottomSurfaceFile_);</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;    link_.AddFilename(bottom_surface_.kBottomSurfaceFile_.c_str(), <a class="code" href="namespace_pz_g.html#ab0580cdb6bfe9e51d7de2588bc824076af8f97c84dadf8eaa1f0370861e15dfec">PzG::LS_CONTINUOUS</a>, 1);</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    water_surface_.draw(water_surface_.kWaterSurfaceFile_);</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    link_.AddFilename(water_surface_.kWaterSurfaceFile_.c_str(), <a class="code" href="namespace_pz_g.html#ab0580cdb6bfe9e51d7de2588bc824076af8f97c84dadf8eaa1f0370861e15dfec">PzG::LS_CONTINUOUS</a>, 1);</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160; </div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    rod_.draw(rod_.kObstacleRodFile);</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    link_.AddFilename(rod_.kObstacleRodFile.c_str(), <a class="code" href="namespace_pz_g.html#ab0580cdb6bfe9e51d7de2588bc824076af8f97c84dadf8eaa1f0370861e15dfec">PzG::LS_CONTINUOUS</a>, 1);</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160; </div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    rectangle_.draw(rectangle_.kObstacleRectangleFile);</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    link_.AddFilename(rectangle_.kObstacleRectangleFile.c_str(), <a class="code" href="namespace_pz_g.html#ab0580cdb6bfe9e51d7de2588bc824076af8f97c84dadf8eaa1f0370861e15dfec">PzG::LS_CONTINUOUS</a>, 1);</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    cuboid_obstacle_.draw(cuboid_obstacle_.kObstacleCuboidFile);</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    link_.AddFilename(cuboid_obstacle_.kObstacleCuboidFile.c_str(), <a class="code" href="namespace_pz_g.html#ab0580cdb6bfe9e51d7de2588bc824076af8f97c84dadf8eaa1f0370861e15dfec">PzG::LS_CONTINUOUS</a>, 1);</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160; </div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    drone_.draw(drone_.kDroneFile,</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;                drone_.kLeftFrontRotorFile_,</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;                drone_.kRightFrontRotorFile_,</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;                drone_.kLeftRearRotorFile_,</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;                drone_.kRightRearRotorFile_);</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    link_.AddFilename(drone_.kDroneFile.c_str(), <a class="code" href="namespace_pz_g.html#ab0580cdb6bfe9e51d7de2588bc824076af8f97c84dadf8eaa1f0370861e15dfec">PzG::LS_CONTINUOUS</a>, 1);</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    link_.AddFilename(drone_.kLeftFrontRotorFile_.c_str(), <a class="code" href="namespace_pz_g.html#ab0580cdb6bfe9e51d7de2588bc824076af8f97c84dadf8eaa1f0370861e15dfec">PzG::LS_CONTINUOUS</a>, 1);</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    link_.AddFilename(drone_.kRightFrontRotorFile_.c_str(), <a class="code" href="namespace_pz_g.html#ab0580cdb6bfe9e51d7de2588bc824076af8f97c84dadf8eaa1f0370861e15dfec">PzG::LS_CONTINUOUS</a>, 1);</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    link_.AddFilename(drone_.kLeftRearRotorFile_.c_str(), <a class="code" href="namespace_pz_g.html#ab0580cdb6bfe9e51d7de2588bc824076af8f97c84dadf8eaa1f0370861e15dfec">PzG::LS_CONTINUOUS</a>, 1);</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    link_.AddFilename(drone_.kRightRearRotorFile_.c_str(), <a class="code" href="namespace_pz_g.html#ab0580cdb6bfe9e51d7de2588bc824076af8f97c84dadf8eaa1f0370861e15dfec">PzG::LS_CONTINUOUS</a>, 1);</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160; </div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    link_.Draw();</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;}</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160; </div>
<div class="line"><a name="l00043"></a><span class="lineno"><a class="line" href="class_scene.html#a806fccf2f53e666749ea8abf76190c62">   43</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="class_scene.html#a806fccf2f53e666749ea8abf76190c62">Scene::checkCollision</a>(<span class="keyword">const</span> vector&lt;Vector3D&gt; &amp;droneCover) {</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    vector&lt;shared_ptr&lt;Shape&gt;&gt;</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        objects = objectsOnScene&lt;Drone, bottomSurface, waterSurface, Rod, Rectangle, CuboidObstacle&gt;();</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160; </div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keywordflow">for</span> (<span class="keyword">const</span> <span class="keyword">auto</span> &amp;<span class="keywordtype">object</span> : objects) {</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        <span class="keywordflow">if</span> (object-&gt;checkCollision(droneCover)) {</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;            <span class="keywordtype">object</span>-&gt;getCollisionInformation();</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        }</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    }</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160; </div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;}</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160; </div>
<div class="line"><a name="l00057"></a><span class="lineno"><a class="line" href="class_scene.html#a0a3d83da2246b9e98c9e04cef38e1778">   57</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="class_scene.html#a0a3d83da2246b9e98c9e04cef38e1778">Scene::animation</a>(<span class="keywordtype">double</span> rotateAngle) {</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160; </div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> i = 0; i &lt; frames_; ++i) {</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        drone_.rotate(rotateAngle, frames_);</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        link_.Draw();</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        sleep_for(microseconds(frameFreeze_));</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    }</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;}</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160; </div>
<div class="line"><a name="l00066"></a><span class="lineno"><a class="line" href="class_scene.html#a45aadc8e5a63422972db07fd9b0e8b76">   66</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="class_scene.html#a0a3d83da2246b9e98c9e04cef38e1778">Scene::animation</a>(<span class="keyword">const</span> <span class="keywordtype">double</span> &amp;angleChange, <span class="keyword">const</span> <span class="keywordtype">double</span> &amp;distance) {</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160; </div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> i = 0; i &lt; frames_; ++i) {</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        <span class="keywordflow">if</span> (checkCollision(drone_.moveForward(angleChange, distance, frames_))) {</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        }</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        link_.Draw();</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        sleep_for(microseconds(frameFreeze_));</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160; </div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    }</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;}</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160; </div>
<div class="line"><a name="l00078"></a><span class="lineno"><a class="line" href="class_scene.html#a6a8e842f5988fa87c6880684d22a6c15">   78</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="class_scene.html#a6a8e842f5988fa87c6880684d22a6c15">Scene::displayObjectCount</a>() {</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    cout &lt;&lt; <span class="stringliteral">&quot;   Current number of Vector3D objects: &quot;</span> &lt;&lt; <a class="code" href="class_shape.html#aa807a43b362e4ef73df68fe95813ec4a">Shape::currentCounter_</a> &lt;&lt; endl;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    cout &lt;&lt; <span class="stringliteral">&quot; The total number of Vector3D objects: &quot;</span> &lt;&lt; <a class="code" href="class_shape.html#a52b1f33f515746a215cd461bcd5e5d3f">Shape::allCounter_</a> &lt;&lt; endl;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    cout &lt;&lt; endl;</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;}</div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="anamespace_pz_g_html_ab0580cdb6bfe9e51d7de2588bc824076af8f97c84dadf8eaa1f0370861e15dfec"><div class="ttname"><a href="namespace_pz_g.html#ab0580cdb6bfe9e51d7de2588bc824076af8f97c84dadf8eaa1f0370861e15dfec">PzG::LS_CONTINUOUS</a></div><div class="ttdeci">@ LS_CONTINUOUS</div><div class="ttdef"><b>Definition:</b> <a href="gnuplot__link_8hh_source.html#l00048">gnuplot_link.hh:48</a></div></div>
<div class="ttc" id="aclass_scene_html_a0a3d83da2246b9e98c9e04cef38e1778"><div class="ttname"><a href="class_scene.html#a0a3d83da2246b9e98c9e04cef38e1778">Scene::animation</a></div><div class="ttdeci">void animation(double rotateAngle)</div><div class="ttdoc">Implements rotation animation.</div><div class="ttdef"><b>Definition:</b> <a href="scene_8cpp_source.html#l00057">scene.cpp:57</a></div></div>
<div class="ttc" id="aclass_shape_html_a52b1f33f515746a215cd461bcd5e5d3f"><div class="ttname"><a href="class_shape.html#a52b1f33f515746a215cd461bcd5e5d3f">Shape::allCounter_</a></div><div class="ttdeci">static unsigned allCounter_</div><div class="ttdoc">Number of total Vector3D objects.</div><div class="ttdef"><b>Definition:</b> <a href="shape_8hh_source.html#l00035">shape.hh:35</a></div></div>
<div class="ttc" id="aclass_scene_html_ad10176d75a9cc0da56626f682d083507"><div class="ttname"><a href="class_scene.html#ad10176d75a9cc0da56626f682d083507">Scene::Scene</a></div><div class="ttdeci">Scene()</div><div class="ttdoc">Constructor for Scene class.</div><div class="ttdef"><b>Definition:</b> <a href="scene_8cpp_source.html#l00010">scene.cpp:10</a></div></div>
<div class="ttc" id="anamespace_pz_g_html_a4360c76a1dbf714a19a0d97fe56e0660aa7ef207217913b87d83fdf559d8368c7"><div class="ttname"><a href="namespace_pz_g.html#a4360c76a1dbf714a19a0d97fe56e0660aa7ef207217913b87d83fdf559d8368c7">PzG::DM_3D</a></div><div class="ttdeci">@ DM_3D</div><div class="ttdef"><b>Definition:</b> <a href="gnuplot__link_8hh_source.html#l00042">gnuplot_link.hh:42</a></div></div>
<div class="ttc" id="aclass_shape_html_aa807a43b362e4ef73df68fe95813ec4a"><div class="ttname"><a href="class_shape.html#aa807a43b362e4ef73df68fe95813ec4a">Shape::currentCounter_</a></div><div class="ttdeci">static unsigned currentCounter_</div><div class="ttdoc">Number of current Vector3D objects.</div><div class="ttdef"><b>Definition:</b> <a href="shape_8hh_source.html#l00040">shape.hh:40</a></div></div>
<div class="ttc" id="aclass_scene_html_a806fccf2f53e666749ea8abf76190c62"><div class="ttname"><a href="class_scene.html#a806fccf2f53e666749ea8abf76190c62">Scene::checkCollision</a></div><div class="ttdeci">bool checkCollision(const std::vector&lt; Vector3D &gt; &amp;droneCover)</div><div class="ttdoc">Check drone collision with objects on scene.</div><div class="ttdef"><b>Definition:</b> <a href="scene_8cpp_source.html#l00043">scene.cpp:43</a></div></div>
<div class="ttc" id="ascene_8hh_html"><div class="ttname"><a href="scene_8hh.html">scene.hh</a></div></div>
<div class="ttc" id="aclass_scene_html_a6a8e842f5988fa87c6880684d22a6c15"><div class="ttname"><a href="class_scene.html#a6a8e842f5988fa87c6880684d22a6c15">Scene::displayObjectCount</a></div><div class="ttdeci">static void displayObjectCount()</div><div class="ttdoc">Displays the number of Vector3D objects.</div><div class="ttdef"><b>Definition:</b> <a href="scene_8cpp_source.html#l00078">scene.cpp:78</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_167790342fb55959539d550b874be046.html">project</a></li><li class="navelem"><a class="el" href="dir_f77a644fded742ea05ed17fa0fdf6fe1.html">src</a></li><li class="navelem"><a class="el" href="scene_8cpp.html">scene.cpp</a></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.17 </li>
  </ul>
</div>
</body>
</html>
